Index: i18n/en.ts
===================================================================
--- i18n/en.ts	(revision 134a9158bdb06b4a9e30aa4386a1a0f0ce5b3320)
+++ i18n/en.ts	(revision b968056ce39d47e4966f4d964830fdd59bc9e90f)
@@ -111,81 +111,81 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="127"/>
-        <location filename="../src/mainwindow.cpp" line="316"/>
-        <location filename="../src/mainwindow.cpp" line="325"/>
+        <location filename="../src/mainwindow.cpp" line="134"/>
+        <location filename="../src/mainwindow.cpp" line="323"/>
+        <location filename="../src/mainwindow.cpp" line="332"/>
         <source>Language change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="127"/>
+        <location filename="../src/mainwindow.cpp" line="134"/>
         <source>Unable to load translation language.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
         <source>New Task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="155"/>
-        <location filename="../src/mainwindow.cpp" line="166"/>
-        <location filename="../src/mainwindow.cpp" line="339"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
+        <location filename="../src/mainwindow.cpp" line="173"/>
+        <location filename="../src/mainwindow.cpp" line="346"/>
         <source>Would you like to save changes in current task?</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="166"/>
+        <location filename="../src/mainwindow.cpp" line="173"/>
         <source>Task Open</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="173"/>
+        <location filename="../src/mainwindow.cpp" line="180"/>
         <source>All Supported Formats</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="174"/>
-        <location filename="../src/mainwindow.cpp" line="175"/>
+        <location filename="../src/mainwindow.cpp" line="181"/>
+        <location filename="../src/mainwindow.cpp" line="182"/>
         <source>%1 Task Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="176"/>
-        <location filename="../src/mainwindow.cpp" line="196"/>
+        <location filename="../src/mainwindow.cpp" line="183"/>
+        <location filename="../src/mainwindow.cpp" line="203"/>
         <source>All Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="195"/>
+        <location filename="../src/mainwindow.cpp" line="202"/>
         <source>%1 Task File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="252"/>
+        <location filename="../src/mainwindow.cpp" line="259"/>
         <source>Data error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="252"/>
+        <location filename="../src/mainwindow.cpp" line="259"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="261"/>
+        <location filename="../src/mainwindow.cpp" line="268"/>
         <source>Solution error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="261"/>
+        <location filename="../src/mainwindow.cpp" line="268"/>
         <source>There was an error while solving the task.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="316"/>
+        <location filename="../src/mainwindow.cpp" line="323"/>
         <source>Language will be autodetected on next application start.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="325"/>
+        <location filename="../src/mainwindow.cpp" line="332"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -194,5 +194,5 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="339"/>
+        <location filename="../src/mainwindow.cpp" line="346"/>
         <source>Application Close</source>
         <translation type="unfinished"></translation>
@@ -247,48 +247,72 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="185"/>
-        <location filename="../ui/mainwindow.ui" line="164"/>
+        <location filename="../ui/mainwindow.ce.ui" line="189"/>
+        <location filename="../ui/mainwindow.ui" line="168"/>
         <source>Solve current task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="188"/>
-        <location filename="../ui/mainwindow.ui" line="167"/>
+        <location filename="../ui/mainwindow.ce.ui" line="192"/>
+        <location filename="../ui/mainwindow.ui" line="171"/>
         <source>Solve</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="202"/>
-        <location filename="../ui/mainwindow.ui" line="181"/>
+        <location filename="../ui/mainwindow.ce.ui" line="206"/>
+        <location filename="../ui/mainwindow.ui" line="185"/>
         <source>Solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="219"/>
-        <location filename="../ui/mainwindow.ui" line="198"/>
+        <location filename="../ui/mainwindow.ce.ui" line="223"/>
+        <location filename="../ui/mainwindow.ui" line="202"/>
         <source>Solution steps</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="229"/>
-        <location filename="../ui/mainwindow.ui" line="208"/>
+        <location filename="../ui/mainwindow.ce.ui" line="233"/>
+        <location filename="../ui/mainwindow.ui" line="212"/>
         <source>Solution graph</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="255"/>
-        <location filename="../ui/mainwindow.ui" line="236"/>
+        <location filename="../ui/mainwindow.ce.ui" line="259"/>
+        <location filename="../ui/mainwindow.ui" line="240"/>
         <source>&amp;File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="559"/>
-        <location filename="../ui/mainwindow.ui" line="572"/>
+        <location filename="../ui/mainwindow.ce.ui" line="266"/>
+        <location filename="../ui/mainwindow.ui" line="244"/>
+        <source>Save &amp;As...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
+        <source>Solution S&amp;teps</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="362"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
+        <source>Solution &amp;Graph</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="466"/>
+        <location filename="../ui/mainwindow.ui" line="479"/>
+        <source>Context &amp;Help</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="557"/>
+        <location filename="../ui/mainwindow.ui" line="570"/>
         <source>&amp;Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="283"/>
-        <location filename="../ui/mainwindow.ui" line="264"/>
+        <location filename="../ui/mainwindow.ce.ui" line="287"/>
+        <location filename="../ui/mainwindow.ui" line="268"/>
         <source>&amp;Settings</source>
         <translation type="unfinished"></translation>
@@ -301,330 +325,309 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="262"/>
-        <location filename="../ui/mainwindow.ui" line="240"/>
-        <source>Save &amp;as...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="293"/>
-        <location filename="../ui/mainwindow.ui" line="274"/>
+        <location filename="../ui/mainwindow.ce.ui" line="297"/>
+        <location filename="../ui/mainwindow.ui" line="278"/>
         <source>&amp;Language</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="309"/>
-        <location filename="../ui/mainwindow.ui" line="290"/>
+        <extracomment>Please, append &quot; / Language&quot; when translating this string.
+----------
+Please, append &quot; / Language&quot; when translating this string.</extracomment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="313"/>
+        <location filename="../ui/mainwindow.ui" line="294"/>
         <source>&amp;Help</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="350"/>
-        <location filename="../ui/mainwindow.ui" line="363"/>
-        <source>Solution st&amp;eps</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="353"/>
-        <location filename="../ui/mainwindow.ui" line="366"/>
+        <location filename="../ui/mainwindow.ce.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="364"/>
         <source>Save solution steps</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="356"/>
-        <location filename="../ui/mainwindow.ui" line="369"/>
+        <location filename="../ui/mainwindow.ce.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="367"/>
         <source>Save solution steps only</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="364"/>
-        <location filename="../ui/mainwindow.ui" line="377"/>
-        <source>Solution &amp;graph</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="367"/>
-        <location filename="../ui/mainwindow.ui" line="380"/>
+        <location filename="../ui/mainwindow.ce.ui" line="365"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
         <source>Save solution graph</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="370"/>
-        <location filename="../ui/mainwindow.ui" line="383"/>
+        <location filename="../ui/mainwindow.ce.ui" line="368"/>
+        <location filename="../ui/mainwindow.ui" line="381"/>
         <source>Save solution graph only</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="378"/>
-        <location filename="../ui/mainwindow.ui" line="391"/>
+        <location filename="../ui/mainwindow.ce.ui" line="376"/>
+        <location filename="../ui/mainwindow.ui" line="389"/>
         <source>&amp;Solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="381"/>
-        <location filename="../ui/mainwindow.ui" line="394"/>
+        <location filename="../ui/mainwindow.ce.ui" line="379"/>
+        <location filename="../ui/mainwindow.ui" line="392"/>
         <source>Save solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="384"/>
-        <location filename="../ui/mainwindow.ui" line="397"/>
+        <location filename="../ui/mainwindow.ce.ui" line="382"/>
+        <location filename="../ui/mainwindow.ui" line="395"/>
         <source>Save solution steps and graph</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="393"/>
-        <location filename="../ui/mainwindow.ui" line="406"/>
+        <location filename="../ui/mainwindow.ce.ui" line="391"/>
+        <location filename="../ui/mainwindow.ui" line="404"/>
         <source>&amp;New</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="396"/>
-        <location filename="../ui/mainwindow.ui" line="409"/>
+        <location filename="../ui/mainwindow.ce.ui" line="394"/>
+        <location filename="../ui/mainwindow.ui" line="407"/>
         <source>New</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="399"/>
-        <location filename="../ui/mainwindow.ui" line="412"/>
+        <location filename="../ui/mainwindow.ce.ui" line="397"/>
+        <location filename="../ui/mainwindow.ui" line="410"/>
         <source>New task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="402"/>
-        <location filename="../ui/mainwindow.ui" line="415"/>
+        <location filename="../ui/mainwindow.ce.ui" line="400"/>
+        <location filename="../ui/mainwindow.ui" line="413"/>
         <source>Create new task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="405"/>
-        <location filename="../ui/mainwindow.ui" line="418"/>
+        <location filename="../ui/mainwindow.ce.ui" line="403"/>
+        <location filename="../ui/mainwindow.ui" line="416"/>
         <source>Ctrl+N</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="414"/>
-        <location filename="../ui/mainwindow.ui" line="427"/>
+        <location filename="../ui/mainwindow.ce.ui" line="412"/>
+        <location filename="../ui/mainwindow.ui" line="425"/>
         <source>&amp;Open...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="417"/>
-        <location filename="../ui/mainwindow.ui" line="430"/>
+        <location filename="../ui/mainwindow.ce.ui" line="415"/>
+        <location filename="../ui/mainwindow.ui" line="428"/>
         <source>Open...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="420"/>
-        <location filename="../ui/mainwindow.ui" line="433"/>
+        <location filename="../ui/mainwindow.ce.ui" line="418"/>
+        <location filename="../ui/mainwindow.ui" line="431"/>
         <source>Open task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="423"/>
-        <location filename="../ui/mainwindow.ui" line="436"/>
+        <location filename="../ui/mainwindow.ce.ui" line="421"/>
+        <location filename="../ui/mainwindow.ui" line="434"/>
         <source>Open saved task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="426"/>
-        <location filename="../ui/mainwindow.ui" line="439"/>
+        <location filename="../ui/mainwindow.ce.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="437"/>
         <source>Ctrl+O</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="435"/>
-        <location filename="../ui/mainwindow.ui" line="448"/>
+        <location filename="../ui/mainwindow.ce.ui" line="433"/>
+        <location filename="../ui/mainwindow.ui" line="446"/>
         <source>&amp;Preferences...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="438"/>
-        <location filename="../ui/mainwindow.ui" line="451"/>
+        <location filename="../ui/mainwindow.ce.ui" line="436"/>
+        <location filename="../ui/mainwindow.ui" line="449"/>
         <source>Preferences...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="441"/>
-        <location filename="../ui/mainwindow.ui" line="454"/>
+        <location filename="../ui/mainwindow.ce.ui" line="439"/>
+        <location filename="../ui/mainwindow.ui" line="452"/>
         <source>Application preferences</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="453"/>
-        <location filename="../ui/mainwindow.ui" line="466"/>
+        <location filename="../ui/mainwindow.ce.ui" line="451"/>
+        <location filename="../ui/mainwindow.ui" line="464"/>
         <source>&amp;Contents</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="456"/>
-        <location filename="../ui/mainwindow.ui" line="469"/>
+        <location filename="../ui/mainwindow.ce.ui" line="454"/>
+        <location filename="../ui/mainwindow.ui" line="467"/>
         <source>Open help contents</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="468"/>
-        <location filename="../ui/mainwindow.ui" line="481"/>
-        <source>&amp;Context help</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="471"/>
-        <location filename="../ui/mainwindow.ui" line="484"/>
+        <location filename="../ui/mainwindow.ce.ui" line="469"/>
+        <location filename="../ui/mainwindow.ui" line="482"/>
         <source>Open context help</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="480"/>
-        <location filename="../ui/mainwindow.ui" line="493"/>
+        <location filename="../ui/mainwindow.ce.ui" line="478"/>
+        <location filename="../ui/mainwindow.ui" line="491"/>
         <source>&amp;About...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="483"/>
-        <location filename="../ui/mainwindow.ui" line="496"/>
+        <location filename="../ui/mainwindow.ce.ui" line="481"/>
+        <location filename="../ui/mainwindow.ui" line="494"/>
         <source>About...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="486"/>
-        <location filename="../ui/mainwindow.ui" line="499"/>
+        <location filename="../ui/mainwindow.ce.ui" line="484"/>
+        <location filename="../ui/mainwindow.ui" line="497"/>
         <source>About application</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="495"/>
-        <location filename="../ui/mainwindow.ui" line="508"/>
+        <location filename="../ui/mainwindow.ce.ui" line="493"/>
+        <location filename="../ui/mainwindow.ui" line="506"/>
         <source>E&amp;xit</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="498"/>
-        <location filename="../ui/mainwindow.ui" line="511"/>
+        <location filename="../ui/mainwindow.ce.ui" line="496"/>
+        <location filename="../ui/mainwindow.ui" line="509"/>
         <source>Exit application</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="507"/>
-        <location filename="../ui/mainwindow.ui" line="520"/>
+        <location filename="../ui/mainwindow.ce.ui" line="505"/>
+        <location filename="../ui/mainwindow.ui" line="518"/>
         <source>&amp;Task...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="510"/>
-        <location filename="../ui/mainwindow.ui" line="523"/>
+        <location filename="../ui/mainwindow.ce.ui" line="508"/>
+        <location filename="../ui/mainwindow.ui" line="521"/>
         <source>Task...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="513"/>
-        <location filename="../ui/mainwindow.ce.ui" line="562"/>
-        <location filename="../ui/mainwindow.ui" line="526"/>
-        <location filename="../ui/mainwindow.ui" line="578"/>
+        <location filename="../ui/mainwindow.ce.ui" line="511"/>
+        <location filename="../ui/mainwindow.ce.ui" line="560"/>
+        <location filename="../ui/mainwindow.ui" line="524"/>
+        <location filename="../ui/mainwindow.ui" line="576"/>
         <source>Save task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="516"/>
-        <location filename="../ui/mainwindow.ui" line="529"/>
+        <location filename="../ui/mainwindow.ce.ui" line="514"/>
+        <location filename="../ui/mainwindow.ui" line="527"/>
         <source>Save task to file</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="519"/>
-        <location filename="../ui/mainwindow.ui" line="532"/>
+        <location filename="../ui/mainwindow.ce.ui" line="517"/>
+        <location filename="../ui/mainwindow.ui" line="530"/>
         <source>Ctrl+S</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="530"/>
-        <location filename="../ui/mainwindow.ui" line="543"/>
+        <location filename="../ui/mainwindow.ce.ui" line="528"/>
+        <location filename="../ui/mainwindow.ui" line="541"/>
         <source>&amp;Autodetect</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="547"/>
+        <location filename="../ui/mainwindow.ce.ui" line="545"/>
         <source>English</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="565"/>
-        <location filename="../ui/mainwindow.ui" line="581"/>
+        <location filename="../ui/mainwindow.ce.ui" line="563"/>
+        <location filename="../ui/mainwindow.ui" line="579"/>
         <source>Save current task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="574"/>
-        <location filename="../ui/mainwindow.ui" line="590"/>
+        <location filename="../ui/mainwindow.ce.ui" line="572"/>
+        <location filename="../ui/mainwindow.ui" line="588"/>
         <source>About &amp;Qt...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="577"/>
-        <location filename="../ui/mainwindow.ui" line="593"/>
+        <location filename="../ui/mainwindow.ce.ui" line="575"/>
+        <location filename="../ui/mainwindow.ui" line="591"/>
         <source>About Qt...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="580"/>
+        <location filename="../ui/mainwindow.ce.ui" line="578"/>
         <source>About Qt</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="583"/>
-        <location filename="../ui/mainwindow.ui" line="596"/>
+        <location filename="../ui/mainwindow.ce.ui" line="581"/>
+        <location filename="../ui/mainwindow.ui" line="594"/>
         <source>About Qt library</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="287"/>
-        <location filename="../ui/mainwindow.ui" line="268"/>
+        <location filename="../ui/mainwindow.ce.ui" line="291"/>
+        <location filename="../ui/mainwindow.ui" line="272"/>
         <source>Select language</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="290"/>
-        <location filename="../ui/mainwindow.ui" line="271"/>
+        <location filename="../ui/mainwindow.ce.ui" line="294"/>
+        <location filename="../ui/mainwindow.ui" line="275"/>
         <source>Select application language</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="334"/>
-        <source>P&amp;rint setup...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="337"/>
+        <location filename="../ui/mainwindow.ui" line="332"/>
+        <source>P&amp;rint Setup...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="335"/>
         <source>Setup printing</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="349"/>
+        <location filename="../ui/mainwindow.ui" line="347"/>
         <source>&amp;Print...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="352"/>
+        <location filename="../ui/mainwindow.ui" line="350"/>
         <source>Print solution results</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="355"/>
+        <location filename="../ui/mainwindow.ui" line="353"/>
         <source>Ctrl+P</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="575"/>
+        <location filename="../ui/mainwindow.ui" line="573"/>
         <source>Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="533"/>
-        <location filename="../ui/mainwindow.ui" line="546"/>
+        <location filename="../ui/mainwindow.ce.ui" line="531"/>
+        <location filename="../ui/mainwindow.ui" line="544"/>
         <source>Detect language automatically</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="536"/>
-        <location filename="../ui/mainwindow.ui" line="549"/>
+        <location filename="../ui/mainwindow.ce.ui" line="534"/>
+        <location filename="../ui/mainwindow.ui" line="547"/>
         <source>Detect language automatically based on regional settings</source>
         <translation type="unfinished"></translation>
Index: i18n/ru.ts
===================================================================
--- i18n/ru.ts	(revision 134a9158bdb06b4a9e30aa4386a1a0f0ce5b3320)
+++ i18n/ru.ts	(revision b968056ce39d47e4966f4d964830fdd59bc9e90f)
@@ -18,5 +18,5 @@
         <location filename="../src/tspmodel.cpp" line="156"/>
         <source>Unexpected end of file.</source>
-        <translation type="unfinished"></translation>
+        <translation>Неожиданный конец файла.</translation>
     </message>
     <message>
@@ -55,5 +55,6 @@
         <source>Unable to open task file.
 Error: %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Невозможно открыть файл задания.
+Ошибка: %1</translation>
     </message>
     <message>
@@ -203,8 +204,4 @@
     </message>
     <message>
-        <source>Travelling salesman problem</source>
-        <translation type="obsolete">Задача коммивояжера</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ce.ui" line="56"/>
         <location filename="../ui/mainwindow.ui" line="35"/>
@@ -291,4 +288,22 @@
     </message>
     <message>
+        <location filename="../ui/mainwindow.ce.ui" line="266"/>
+        <location filename="../ui/mainwindow.ui" line="244"/>
+        <source>Save &amp;As...</source>
+        <translation>Сохранить &amp;как...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
+        <source>Solution S&amp;teps</source>
+        <translation>&amp;Ход решения</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="362"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
+        <source>Solution &amp;Graph</source>
+        <translation>&amp;Граф решения</translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="466"/>
         <location filename="../ui/mainwindow.ui" line="479"/>
@@ -313,10 +328,4 @@
         <source>Travelling salesman problem[*]</source>
         <translation>Задача коммивояжера[*]</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="266"/>
-        <location filename="../ui/mainwindow.ui" line="244"/>
-        <source>Save &amp;as...</source>
-        <translation>Сохранить &amp;как...</translation>
     </message>
     <message>
@@ -336,10 +345,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="348"/>
-        <location filename="../ui/mainwindow.ui" line="361"/>
-        <source>Solution st&amp;eps</source>
-        <translation>&amp;Ход решения</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ce.ui" line="351"/>
         <location filename="../ui/mainwindow.ui" line="364"/>
@@ -354,10 +357,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="375"/>
-        <source>Solution &amp;graph</source>
-        <translation>&amp;Граф решения</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ce.ui" line="365"/>
         <location filename="../ui/mainwindow.ui" line="378"/>
@@ -478,8 +475,4 @@
         <source>Open help contents</source>
         <translation>Вызвать справку программы</translation>
-    </message>
-    <message>
-        <source>&amp;Context help</source>
-        <translation type="obsolete">&amp;Контекстная справка</translation>
     </message>
     <message>
@@ -605,5 +598,5 @@
     <message>
         <location filename="../ui/mainwindow.ui" line="332"/>
-        <source>P&amp;rint setup...</source>
+        <source>P&amp;rint Setup...</source>
         <translation>&amp;Настройка печати...</translation>
     </message>
Index: i18n/uk.ts
===================================================================
--- i18n/uk.ts	(revision 134a9158bdb06b4a9e30aa4386a1a0f0ce5b3320)
+++ i18n/uk.ts	(revision b968056ce39d47e4966f4d964830fdd59bc9e90f)
@@ -18,5 +18,5 @@
         <location filename="../src/tspmodel.cpp" line="156"/>
         <source>Unexpected end of file.</source>
-        <translation type="unfinished"></translation>
+        <translation>Неочікуваний кінець файлу.</translation>
     </message>
     <message>
@@ -55,5 +55,6 @@
         <source>Unable to open task file.
 Error: %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Неможливо відкрити файл завдання.
+Помилка: %1</translation>
     </message>
     <message>
@@ -138,5 +139,5 @@
     <message>
         <location filename="../ui/mainwindow.ui" line="332"/>
-        <source>P&amp;rint setup...</source>
+        <source>P&amp;rint Setup...</source>
         <translation>&amp;Налагодження друку...</translation>
     </message>
@@ -191,8 +192,4 @@
     </message>
     <message>
-        <source>Travelling salesman problem</source>
-        <translation type="obsolete">Задача комівояжера</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ce.ui" line="56"/>
         <location filename="../ui/mainwindow.ui" line="35"/>
@@ -267,4 +264,22 @@
     </message>
     <message>
+        <location filename="../ui/mainwindow.ce.ui" line="266"/>
+        <location filename="../ui/mainwindow.ui" line="244"/>
+        <source>Save &amp;As...</source>
+        <translation>Зберегти &amp;як...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
+        <source>Solution S&amp;teps</source>
+        <translation>&amp;Хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="362"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
+        <source>Solution &amp;Graph</source>
+        <translation>&amp;Граф розв&apos;язку</translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="466"/>
         <location filename="../ui/mainwindow.ui" line="479"/>
@@ -289,10 +304,4 @@
         <source>Travelling salesman problem[*]</source>
         <translation>Задача комівояжера[*]</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="266"/>
-        <location filename="../ui/mainwindow.ui" line="244"/>
-        <source>Save &amp;as...</source>
-        <translation>Зберегти &amp;як...</translation>
     </message>
     <message>
@@ -312,10 +321,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="348"/>
-        <location filename="../ui/mainwindow.ui" line="361"/>
-        <source>Solution st&amp;eps</source>
-        <translation>&amp;Хід розв&apos;язку</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ce.ui" line="351"/>
         <location filename="../ui/mainwindow.ui" line="364"/>
@@ -330,10 +333,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="375"/>
-        <source>Solution &amp;graph</source>
-        <translation>&amp;Граф розв&apos;язку</translation>
-    </message>
-    <message>
         <location filename="../ui/mainwindow.ce.ui" line="365"/>
         <location filename="../ui/mainwindow.ui" line="378"/>
@@ -448,8 +445,4 @@
         <source>Open help contents</source>
         <translation>Відкрити зміст допомоги</translation>
-    </message>
-    <message>
-        <source>&amp;Context help</source>
-        <translation type="obsolete">&amp;Контекстна допомога</translation>
     </message>
     <message>
